// CalculatorDoc.cpp : implementation of the CCalculatorDoc class
//

#include "stdafx.h"
#include "Calculator.h"
#include "StrDialog.h"

#include "CalculatorDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCalculatorDoc

IMPLEMENT_DYNCREATE(CCalculatorDoc, CDocument)

BEGIN_MESSAGE_MAP(CCalculatorDoc, CDocument)
	//{{AFX_MSG_MAP(CCalculatorDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalculatorDoc construction/destruction

CCalculatorDoc::CCalculatorDoc()
{
	// TODO: add one-time construction code here
	TheTop=NULL;
	str="cos(4*x)*cos(2*x)";
	StrChanged();
	Answer=+1;
	squares=new double*[4];
	for(int i=0;i<4;i++)
	{
		squares[i]=new double[6];
		for(int j=0;j<3;j++)
		{
			squares[i][j]=0;
		}
	}
	a=-100;
	b=100;
	ReCountSquares();
}

CCalculatorDoc::~CCalculatorDoc()
{
	if(TheTop)
		delete TheTop;
}

BOOL CCalculatorDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCalculatorDoc serialization

void CCalculatorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCalculatorDoc diagnostics

#ifdef _DEBUG
void CCalculatorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCalculatorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCalculatorDoc commands

//DEL void CCalculatorDoc::OnOpenstrdialog() 
//DEL {
//DEL 		
//DEL }

void CCalculatorDoc::StrChanged()
{
	if(TheTop!=NULL)delete TheTop;
	TheTop=new TreeNode(str);
}

void CCalculatorDoc::ReCountSquares()
{
	
	squares[0][0]=squareSquare(50);
	squares[0][1]=squareSquare(150);
	squares[0][2]=squareSquare(200);
	squares[0][3]=squareSquare(500);
	squares[0][4]=squareSquare(1000);
	squares[0][5]=squareSquare(5000);
	
	squares[1][0]=trapecSquare(50);
	squares[1][1]=trapecSquare(150);
	squares[1][2]=trapecSquare(200);
	squares[1][3]=trapecSquare(500);
	squares[1][4]=trapecSquare(1000);
	squares[1][5]=trapecSquare(5000);
	
	squares[2][0]=SimpsonSquare(50);
	squares[2][1]=SimpsonSquare(150);
	squares[2][2]=SimpsonSquare(200);
	squares[2][3]=SimpsonSquare(500);
	squares[2][4]=SimpsonSquare(1000);
	squares[2][5]=SimpsonSquare(5000);
	
	squares[3][0]=MonteSquare(50);
	squares[3][1]=MonteSquare(150);
	squares[3][2]=MonteSquare(200);
	squares[3][3]=MonteSquare(500);
	squares[3][4]=MonteSquare(1000);
	squares[3][5]=MonteSquare(5000);

}
double modul(double tttt)
{
	if(tttt>0) return tttt;
	else return (-tttt);
}

double CCalculatorDoc::squareSquare(int nnn)
{
	double result=0;
	double del=(b-(double)a)/(double)nnn;
	for(double x1=a+del;x1<=b;x1+=del)
	{
		TreeNode::x=x1;
		result+=del*modul(TheTop->Calculate());
	}
	return result;
}

double CCalculatorDoc::trapecSquare(int nnn)
{
	double result=0;
	double del=(b-(double)a)/(double)nnn;
	TreeNode::x=a;
	double lastfunc=TheTop->Calculate();
	for(double x1=a+del;x1<=b;x1+=del)
	{
		TreeNode::x=x1;
		double nowfunc=TheTop->Calculate();
		result+=modul((lastfunc+nowfunc)/2.0)*del;
		lastfunc=nowfunc;
	}
	return result;
}


double CCalculatorDoc::SimpsonSquare(int nnn)
{
	double result=0;
	double del=(double)(b-(double)a)/(double)nnn;
	for(double x1=a+del;x1<=b;x1+=del)
	{
		TreeNode::x=x1;
		double temp=0;
		TreeNode::x=x1-(double)del;
		temp+=TheTop->Calculate();
		TreeNode::x=x1-(double)0.5*del;
		temp+=4.0*(double)TheTop->Calculate();
		TreeNode::x=(double)x1;
		temp+=TheTop->Calculate();

		result+=modul(temp);
	}
	result*=(del/6.0);
	return result;
}

double CCalculatorDoc::MonteSquare(int nnn)
{
	double result=0;
	for(int i=0;i<nnn;i++)
	{
		double temp=rand()/(double)RAND_MAX;
		temp*=(b-(double)a);
		temp+=(double)a;
		TreeNode::x=temp;
		result+=modul(TheTop->Calculate());
	}
	result=result*(double)(b-(double)a)/(double)((double)nnn);
	return result;
}
