// TreeNode.cpp: implementation of the TreeNode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Calculator.h"
#include "TreeNode.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//float TreeNode::x;
TreeNode::TreeNode()
{

}

TreeNode::~TreeNode()
{
	delete leftNode;
	delete RightNode;
}

double TreeNode::Calculate()
{
	if(IsFunctional)
	switch(Function)
	{
		case -1: return 0;
		case 0: return leftNode->Calculate()+RightNode->Calculate();
		case 1: return leftNode->Calculate()-RightNode->Calculate();
		case 2: return leftNode->Calculate()*RightNode->Calculate();
		case 3: return leftNode->Calculate()/RightNode->Calculate();
		case 4: return pow(leftNode->Calculate(),RightNode->Calculate());
		case 5: return (-leftNode->Calculate());
		case 6: return sin(leftNode->Calculate());
		case 7: return cos(leftNode->Calculate());
		case 8: return tan(leftNode->Calculate());
		case 9: return atan(leftNode->Calculate());
		case 10: return sqrt(leftNode->Calculate());
		//case 11: return x;
	}
	else 
	{
		if(IsXYZ)
		{
			return TreeNode::x;
		}
		else
			return NodeValue;	
	}
}

TreeNode::TreeNode(CString str)
{
	leftNode=RightNode=NULL;
	IsXYZ=false;
	UnarOperation=false;
	for(int i=str.GetLength()-1;i>0;i--)
	{
		if(str[i]==')') 
		{
			int tempI=i;
			int count=1;
			i--;
			while((count>0)&&(i>=0))
			{
				if(str[i]==')') count++;
				if(str[i]=='(') count--;
				i--;
			}
			if(!count) i++;
			if(i==-1) 
			{
				IsFunctional=true;
				Function=-1;
				return;
			}
			if((tempI==(str.GetLength()-1))&&(!i))
			{
				str.Delete(str.GetLength()-1);
				str.Delete(0);
				i=str.GetLength();
			}
			continue;				
		}
		if(!i) continue;
		if((str[i]=='+')|(str[i]=='-'))
		{
			IsFunctional=true;
			Function=(str[i]=='-');
			CString astr=str.Left(i);
			CString bstr=str.Right(str.GetLength()-1-i);
			leftNode=new TreeNode(astr);
			RightNode=new TreeNode(bstr);
			return;
		}
	}
	for(i=str.GetLength()-1;i>0;i--)
	{
		if(str[i]==')') 
		{
			int tempI=i;
			int count=1;
			i--;
			while((count>0)&&(i>=0))
			{
				if(str[i]==')') count++;
				if(str[i]=='(') count--;
				i--;
			}
			if(!count) i++;
			if(i==-1) 
			{
				IsFunctional=true;
				Function=-1;
				return;
			}
			if((tempI==(str.GetLength()-1))&&(!i))
			{
				str.Delete(str.GetLength()-1);
				str.Delete(0);
				i=str.GetLength();
			}
			continue;				
		}
		if(!i) continue;
		if((str[i]=='/')|(str[i]=='*'))
		{
			IsFunctional=true;
			Function=(str[i]=='/')+2;
			CString astr=str.Left(i);
			CString bstr=str.Right(str.GetLength()-1-i);
			leftNode=new TreeNode(astr);
			RightNode=new TreeNode(bstr);
			return;
		}
	}
	if(str.GetLength())
	{
		if(str[0]=='-')
		{
			IsFunctional=true;
			UnarOperation=true;
			Function=5;
			str.Delete(0);
			leftNode=new TreeNode(str);
			return;
		}
		if(str[0]=='+')
		{
			str.Delete(0);
		}
	}

	for(i=str.GetLength()-1;i>0;i--)
	{
		if(str[i]==')') 
		{
			int tempI=i;
			int count=1;
			i--;
			while((count>0)&&(i>=0))
			{
				if(str[i]==')') count++;
				if(str[i]=='(') count--;
				i--;
			}
			if(!count) i++;
			if(i==-1) 
			{
				IsFunctional=true;
				Function=-1;
				return;
			}
			if((tempI==(str.GetLength()-1))&&(!i))
			{
				str.Delete(str.GetLength()-1);
				str.Delete(0);
				i=str.GetLength();
			}
			continue;				
		}
		if(!i) continue;
		if((str[i]=='^'))
		{
			IsFunctional=true;
			Function=4;
			CString astr=str.Left(i);
			CString bstr=str.Right(str.GetLength()-1-i);
			leftNode=new TreeNode(astr);
			RightNode=new TreeNode(bstr);
			return;
		}
	}
	
	//////////////////!!!!!!!!!!!!!!
	if(str.GetLength())
	{
		if((str.Left(4).Compare("sin(")==0)&&(str[str.GetLength()-1]==')'))
		{
			IsFunctional=true;
			UnarOperation=true;
			Function=6;
			str.Delete(str.GetLength()-1);
			str=str.Right(str.GetLength()-4);
			leftNode=new TreeNode(str);
			return;
		}
		if((str.Left(4).Compare("cos(")==0)&&(str[str.GetLength()-1]==')'))
		{
			IsFunctional=true;
			UnarOperation=true;
			Function=7;
			str.Delete(str.GetLength()-1);
			str=str.Right(str.GetLength()-4);
			leftNode=new TreeNode(str);
			return;
		}
		if((str.Left(4).Compare("tan(")==0)&&(str[str.GetLength()-1]==')'))
		{
			IsFunctional=true;
			UnarOperation=true;
			Function=8;
			str.Delete(str.GetLength()-1);
			str=str.Right(str.GetLength()-4);
			leftNode=new TreeNode(str);
			return;
		}
		if((str.Left(4).Compare("ctg(")==0)&&(str[str.GetLength()-1]==')'))
		{	
			IsFunctional=true;
			UnarOperation=true;
			Function=9;
			str.Delete(str.GetLength()-1);
			str=str.Right(str.GetLength()-4);
			leftNode=new TreeNode(str);
			return;
		}
		if((str.Left(5).Compare("sqrt(")==0)&&(str[str.GetLength()-1]==')'))
		{
			IsFunctional=true;
			UnarOperation=true;
			Function=10;
			str.Delete(str.GetLength()-1);
			str=str.Right(str.GetLength()-5);
			leftNode=new TreeNode(str);
			return;
		}

		if(str.Compare("x")==0)
		{
			IsFunctional=false;
			UnarOperation=false;
			IsXYZ=true;
			return;
		}


	}
	IsFunctional=false;
	NodeValue=atof(str);
}

CString TreeNode::ToString()
{
	if(!IsFunctional) 
	if(IsXYZ)
	{
		CString str="x ";
		//str.Format("%f",TreeNode::x);
		return str;
	}
	else
	{
		CString result;
		char str[50];
		sprintf(str,"%f ",NodeValue);
		result=str;
		return result;
	}
	if(UnarOperation)
	{
		CString result;
		result=leftNode->ToString();
		switch(Function)
		{
		case 5: result+="!- ";
			return result;
		case 6: result+="!sin() ";
			return result;
		case 7: result+="!cos() ";
			return result;
		case 8: result+="!tan() ";
			return result;
		case 9: result+="!ctg() ";
			return result;
		case 10: result+="!sqrt() ";
			return result;
		//case 11: result+="x";
		//	return result;
		default: result+="!ERROR! ";
			return result;
		}
	}
	else
	{
		CString result=leftNode->ToString();
		result+=" ";
		result+=RightNode->ToString();
		switch(Function)
		{
		case 0: result+=" +";
			return result;
		case 1: result+=" -";
			return result;
		case 2: result+=" *";
			return result;
		case 3: result+=" /";
			return result;
		case 4: result+=" ^";
			return result;
		}
	}
		
}

void TreeNode::Draw(CDC* pDC,CPoint point)
{
	if(IsFunctional)
	{
	if(UnarOperation)
	{
		pDC->SelectStockObject(BLACK_PEN);
		switch(Function)
		{
		case 5:pDC->TextOut(point.x,point.y,"!-");
			break;
		case 6:pDC->TextOut(point.x,point.y,"!sin()");
			break;
		case 7:pDC->TextOut(point.x,point.y,"!cos()");
			break;
		case 8:pDC->TextOut(point.x,point.y,"!tan()");
			break;
		case 9:pDC->TextOut(point.x,point.y,"!ctg()");
			break;
		case 10:pDC->TextOut(point.x,point.y,"!sqrt()");
			break;
		default: pDC->TextOut(point.x,point.y,"!ERROR!");			
		}
		CPen Pen(PS_DASHDOTDOT,1,RGB(255,0,0));
		pDC->SelectObject(&Pen);
		CPoint pt=point;
		pt.y+=13;
		pDC->MoveTo(pt);
		pt.y+=20;
		pDC->LineTo(pt);
		leftNode->Draw(pDC,pt);
	}
	else
	{
		pDC->SelectStockObject(BLACK_PEN);
		switch(Function)
		{
		case 0: pDC->TextOut(point.x,point.y,"+");break;
		case 1: pDC->TextOut(point.x,point.y,"-");break;
		case 2: pDC->TextOut(point.x,point.y,"*");break;
		case 3: pDC->TextOut(point.x,point.y,"/");break;
		case 4: pDC->TextOut(point.x,point.y,"^");break;
		default: pDC->TextOut(point.x,point.y,"!ERROR!");
		}
		CPen Pen(PS_DASHDOTDOT,1,RGB(255,0,0));
		pDC->SelectObject(&Pen);
		CPoint pt=point;
		pt.y+=13;
		pDC->MoveTo(pt);
		pt.x-=50;
		pt.y+=20;
		pDC->LineTo(pt);
		leftNode->Draw(pDC,pt);
		CPoint pt2=point;
		pt2.y+=13;
		pDC->MoveTo(pt2);
		pt2.x+=50;
		pt2.y+=20;
		pDC->LineTo(pt2);
		RightNode->Draw(pDC,pt2);
	}
	}
	else 
	if(IsXYZ)
	{
		pDC->TextOut(point.x,point.y,"x");
		return;
	}
	else
	{
		char str[50];
		sprintf(str,"%.2f",NodeValue);
		pDC->TextOut(point.x,point.y,str);
	}
}

void TreeNode::Shorten()
{
	if(leftNode!=NULL) leftNode->Shorten();
	if(RightNode!=NULL) RightNode->Shorten();
	if((!leftNode->IsXYZ)&(!RightNode->IsXYZ)) 
	{
		NodeValue=Calculate();
		IsFunctional=false;
		IsXYZ=false;
		UnarOperation=false;
		delete leftNode;
		delete RightNode;
	}
}
